'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

exports.default = function () {
  (0, _lodash.forEach)(_utils.config, function (_ref) {
    var cron = _ref.cron,
        delay = _ref.delay,
        description = _ref.description,
        _ref$digits = _ref.digits,
        nbDigits = _ref$digits === undefined ? 3 : _ref$digits,
        _ref$firstIndex = _ref.firstIndex,
        firstIndex = _ref$firstIndex === undefined ? 1 : _ref$firstIndex,
        name = _ref.name,
        path = _ref.path,
        url = _ref.url;

    var fileFolderPath = `${destinationPath}/${path}`;
    (0, _mkdirp2.default)(fileFolderPath, function (error) {
      if (error) {
        (0, _utils.log)(`ERROR while creating folder ${fileFolderPath}: ${error}`);
      }
    });

    var onTick = function onTick() {
      (0, _download2.default)(url).then(function (data) {
        var index = (0, _digits2.default)(String(firstIndex++), nbDigits);
        var date = Date.now();

        _fs2.default.writeFileSync(`${fileFolderPath}/` + name.replace(/#|{date}/g, function (match) {
          switch (match) {
            case '#':
              return index;
            case '{date}':
              return date;
          }
        }), data);
      }).then(function () {
        return (0, _utils.log)(`Saved ${description || name}`);
      }, function (error) {
        return (0, _utils.log)(`ERROR while saving ${description || name}: ${error}`);
      });
    };

    return new _cron.CronJob({
      cronTime: cron || `0 0/${delay} * * *`,
      onTick,
      start: true
    });
  });
};

var _cron = require('cron');

var _digits = require('digits');

var _digits2 = _interopRequireDefault(_digits);

var _download = require('download');

var _download2 = _interopRequireDefault(_download);

var _fs = require('fs');

var _fs2 = _interopRequireDefault(_fs);

var _mkdirp = require('mkdirp');

var _mkdirp2 = _interopRequireDefault(_mkdirp);

var _lodash = require('lodash');

var _utils = require('./utils');

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

var destinationPath = _utils.args.destinationPath;
//# sourceMappingURL=index.js.map